Project/my_app/config/routes.rb
Rails.application.routes.draw do
  resources :credit_cards
  resources :orders
  resources :categories
  resources :products
  resources :addresses
  resources :credit_cards
  devise_for :users , controllers: { registrations: 'user/registrations' }

  root 'home#home'

  get 'goodbye', to: 'application#goodbye'

  get 'extra', to: 'application#extra'

  get 'test', to: 'application#test'

  get 'log_out', to: 'extra#new'

  get 'accounts', to: 'users#index', as: 'users'

  get 'profile', to: 'users#show'

end

Project/my_app/app/models/category.rb
class Category < ApplicationRecord
    has_many :products
end

Project/my_app/app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :set_category, only: %i[ show edit update destroy ]
  before_action :authenticate_user!
  before_action :check_admin

  include Pagy::Backend

  # GET /categories or /categories.json
  def index
    @categories = Category.all
    @pagy, @categories = pagy(@categories)
  end

  # GET /categories/1 or /categories/1.json
  def show
  end

  # GET /categories/new
  def new
    @category = Category.new
  end

  # GET /categories/1/edit
  def edit
  end

  # POST /categories or /categories.json
  def create
    @category = Category.new(category_params)

    respond_to do |format|
      if @category.save
        format.html { redirect_to category_url(@category), notice: "Category was successfully created." }
        format.json { render :show, status: :created, location: @category }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /categories/1 or /categories/1.json
  def update
    respond_to do |format|
      if @category.update(category_params)
        format.html { redirect_to category_url(@category), notice: "Category was successfully updated." }
        format.json { render :show, status: :ok, location: @category }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /categories/1 or /categories/1.json
  def destroy
    @category.destroy

    respond_to do |format|
      format.html { redirect_to categories_url, notice: "Category was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_category
      @category = Category.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def category_params
      params.require(:category).permit(:id, :name, :description)
    end
end

Project/my_app/app/helpers/categories_helper.rb
module CategoriesHelper
end

Project/my_app/app/views/categories/_category.html.erb
<div id="<%= dom_id category %>">
</div>

Project/my_app/app/views/categories/_form.html.erb
<%= form_for(@category) do |f| %>
  <div class="form-outline mb-4">
    <%= f.text_field :name, autofocus: true, required: true, class: "form-control", style: "color: white", placeholder: "Name"%>
  </div>
  <br>
  <div class="form-outline mb-4">
    <%= f.text_area :description, autofocus: true, required: true, class: "form-control", style: "color: white", placeholder: "Description"%>
  </div>
  <br>

  <div class="actions">
    <%= f.submit button_text, class: "btn btn-primary btn-block mb-4" %>
  </div>
<% end %>

Project/my_app/app/views/categories/edit.html.erb
<body style="background-color: #E0E0E0; display: flex; flex-direction: column; min-height: 100vh; margin: 0; padding: 0;">
  <div class="d-flex justify-content-center align-items-center" style="height: 90vh;">
    <div class="card" style="width: 34rem; background-color: #332d2d;">
      <div class="container-fluid d-flex justify-content-center align-items-center" style="min-height: 60vh;">
        <div class="row justify-content-center">
            <div class="col-md-12 text-black" style="width: 50vh">
                <h1 style="color: white">Editing Category</h1>

                <%= render 'form', button_text: "Update" %>
                <%= link_to 'Back', categories_path, class: "btn btn-warning" %>
            </div>
        </div>
      </div>
    </div>
  </div>
</body>

Project/my_app/app/views/categories/index.html.erb
<%= javascript_include_tag 'mdb' %>

<style>
  .show-link {
    color: white; /* Default color */
    transition: color 0.3s; /* Transition effect */
  }

  .show-link:hover {
    color: gray; /* Hover color */
  }
</style>

<link rel="preconnect" href="https://fonts.gstatic.com">
<link href="https://fonts.googleapis.com/css2?family=Anton&display=swap" rel="stylesheet">

<body style="background-color: #E0E0E0; height: 100vh; margin: 0; padding: 0;">
<div class="container mt-5">
  <h2 style="font-family: 'Anton', sans-serif;">Categories</h2>
  <%= link_to 'New Category', new_category_path, class: "btn btn-primary mt-1 " %>
  <br>
  <br>
  <%== pagy_info(@pagy) %>
  <br>
  <br>
  <table class="table table-info table-striped table-dark">
      <thead>
        <tr>
          <th scope="col">ID</th>
          <th scope="col">Name</th>
          <th scope="col">Description</th>
          <th scope="col">Actions</th>
        </tr>
      </thead>
      <tbody>
        <% @categories.each do |category| %>
          <tr>
            <td><%= category.id %></td>
            <td><%= category.name %></td>
            <td><%= category.description %></td>
            <td><%= link_to 'Edit', edit_category_path(category), class: 'show-link' %> | <%= link_to 'Destroy', category, data: { turbo_method: :delete, turbo_confirm: 'Are you sure?' }, class: 'show-link' %></td>
          </tr>
        <% end %>
      </tbody>
    </table>
    <%== pagy_nav(@pagy) if @pagy.pages > 1 %>
</div>
</body>

<footer class="text-center text-white mt-4 fixed-bottom">
  <div class="text-center p-2" style="background-color: #332d2d; color: #FFFFFF;">
      © 2023 Basketball Haven
  </div>
</footer>

Project/my_app/app/views/categories/new.html.erb
<body style="background-color: #E0E0E0; display: flex; flex-direction: column; min-height: 100vh; margin: 0; padding: 0;">
  <div class="d-flex justify-content-center align-items-center" style="height: 90vh;">
    <div class="card" style="width: 34rem; background-color: #332d2d;">
      <div class="container-fluid d-flex justify-content-center align-items-center" style="min-height: 60vh;">
        <div class="row justify-content-center">
          <div class="col-md-12 text-black" style="width: 50vh">
            <h1 style="color: white">New Category</h1>
            <br>
            <%= render 'form', button_text: "Create" %>
            <%= link_to 'Back', categories_path, class: "btn btn-warning" %>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>

Project/my_app/app/views/categories/show.html.erb
<div class="card" style="width: 40rem;">
  <div class="card-body">
    <h5 class="card-title"><%= @category.name %></h5>
    <p class="card-text"><%= @category.description %></p>
    <%= link_to 'Edit', edit_category_path(@category), class: "btn btn-primary" %>
    <%= link_to 'Back', categories_path, class: "btn btn-warning" %>
  </div>
</div>